// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f bgppeers.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    pub use std::collections::BTreeMap;
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// BGPPeerSpec defines the desired state of Peer.
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "metallb.io",
    version = "v1beta2",
    kind = "BGPPeer",
    plural = "bgppeers"
)]
#[kube(namespaced)]
#[kube(derive = "Default")]
#[kube(derive = "PartialEq")]
pub struct BGPPeerSpec {
    /// The name of the BFD Profile to be used for the BFD session associated to the BGP session. If not set, the BFD session won't be set up.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "bfdProfile"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub bfd_profile: Option<String>,
    /// Requested BGP connect time, controls how long BGP waits between connection attempts to a neighbor.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "connectTime"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub connect_time: Option<String>,
    /// To set if we want to disable MP BGP that will separate IPv4 and IPv6 route exchanges into distinct BGP sessions.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "disableMP")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub disable_mp: Option<bool>,
    /// DynamicASN detects the AS number to use for the remote end of the session
    /// without explicitly setting it via the ASN field. Limited to:
    /// internal - if the neighbor's ASN is different than MyASN connection is denied.
    /// external - if the neighbor's ASN is the same as MyASN the connection is denied.
    /// ASN and DynamicASN are mutually exclusive and one of them must be specified.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "dynamicASN"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub dynamic_asn: Option<BGPPeerDynamicAsn>,
    /// To set if the BGPPeer is multi-hops away. Needed for FRR mode only.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "ebgpMultiHop"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub ebgp_multi_hop: Option<bool>,
    /// EnableGracefulRestart allows BGP peer to continue to forward data packets
    /// along known routes while the routing protocol information is being
    /// restored. This field is immutable because it requires restart of the BGP
    /// session. Supported for FRR mode only.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "enableGracefulRestart"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub enable_graceful_restart: Option<bool>,
    /// Requested BGP hold time, per RFC4271.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "holdTime")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub hold_time: Option<String>,
    /// Requested BGP keepalive time, per RFC4271.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "keepaliveTime"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub keepalive_time: Option<String>,
    /// AS number to use for the local end of the session.
    #[serde(rename = "myASN")]
    pub my_asn: i32,
    /// Only connect to this peer on nodes that match one of these
    /// selectors.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "nodeSelectors"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub node_selectors: Option<Vec<BGPPeerNodeSelectors>>,
    /// Authentication password for routers enforcing TCP MD5 authenticated sessions
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub password: Option<String>,
    /// passwordSecret is name of the authentication secret for BGP Peer.
    /// the secret must be of type "kubernetes.io/basic-auth", and created in the
    /// same namespace as the MetalLB deployment. The password is stored in the
    /// secret as the key "password".
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "passwordSecret"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub password_secret: Option<BGPPeerPasswordSecret>,
    /// AS number to expect from the remote end of the session.
    /// ASN and DynamicASN are mutually exclusive and one of them must be specified.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "peerASN")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub peer_asn: Option<i32>,
    /// Address to dial when establishing the session.
    #[serde(rename = "peerAddress")]
    pub peer_address: String,
    /// Port to dial when establishing the session.
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "peerPort")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub peer_port: Option<i64>,
    /// BGP router ID to advertise to the peer
    #[serde(default, skip_serializing_if = "Option::is_none", rename = "routerID")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub router_id: Option<String>,
    /// Source address to use when establishing the session.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "sourceAddress"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub source_address: Option<String>,
    /// To set if we want to peer with the BGPPeer using an interface belonging to
    /// a host vrf
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub vrf: Option<String>,
}

/// BGPPeerSpec defines the desired state of Peer.
#[derive(Serialize, Deserialize, Clone, Debug, PartialEq)]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub enum BGPPeerDynamicAsn {
    #[serde(rename = "internal")]
    Internal,
    #[serde(rename = "external")]
    External,
}

/// A label selector is a label query over a set of resources. The result of matchLabels and
/// matchExpressions are ANDed. An empty label selector matches all objects. A null
/// label selector matches no objects.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct BGPPeerNodeSelectors {
    /// matchExpressions is a list of label selector requirements. The requirements are ANDed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "matchExpressions"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub match_expressions: Option<Vec<BGPPeerNodeSelectorsMatchExpressions>>,
    /// matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels
    /// map is equivalent to an element of matchExpressions, whose key field is "key", the
    /// operator is "In", and the values array contains only "value". The requirements are ANDed.
    #[serde(
        default,
        skip_serializing_if = "Option::is_none",
        rename = "matchLabels"
    )]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub match_labels: Option<BTreeMap<String, String>>,
}

/// A label selector requirement is a selector that contains values, a key, and an operator that
/// relates the key and values.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct BGPPeerNodeSelectorsMatchExpressions {
    /// key is the label key that the selector applies to.
    pub key: String,
    /// operator represents a key's relationship to a set of values.
    /// Valid operators are In, NotIn, Exists and DoesNotExist.
    pub operator: String,
    /// values is an array of string values. If the operator is In or NotIn,
    /// the values array must be non-empty. If the operator is Exists or DoesNotExist,
    /// the values array must be empty. This array is replaced during a strategic
    /// merge patch.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub values: Option<Vec<String>>,
}

/// passwordSecret is name of the authentication secret for BGP Peer.
/// the secret must be of type "kubernetes.io/basic-auth", and created in the
/// same namespace as the MetalLB deployment. The password is stored in the
/// secret as the key "password".
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct BGPPeerPasswordSecret {
    /// name is unique within a namespace to reference a secret resource.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub name: Option<String>,
    /// namespace defines the space within which the secret name must be unique.
    #[serde(default, skip_serializing_if = "Option::is_none")]
    #[cfg_attr(feature = "builder", builder(default, setter(strip_option)))]
    pub namespace: Option<String>,
}

/// BGPPeerStatus defines the observed state of Peer.
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct BGPPeerStatus {}
